const router = require('express').Router()
import { Thread } from '../db/models'

router.get('/', async (req: any, res: any, next: any) => {
  try {
    Thread.findAllWithIncludes().then((p: any) => res.json(p))
  } catch (err) {
    next(err)
  }
})

router.get('/:id', async (req: any, res: any, next: any) => {
  try {
    Thread.findByIdWithIncludes(req.params.id).then((p: any) => res.json(p))
  } catch (err) {
    next(err)
  }
})

router.post('/', async (req: any, res: any, next: any) => {
  try {
    Thread.create(req.body).then((thread: any) =>
      Thread.findByIdWithIncludes(thread.id).then((p: any) => res.json(p))
    )
  } catch (err) {
    next(err)
  }
})

router.put('/:id', async (req: any, res: any, next: any) => {
  try {
    Thread.findByPk(req.params.id).then((thread: any) =>
      thread
        .update(req.body)
        .then(() =>
          Thread.findByIdWithIncludes(req.params.id).then((p: any) =>
            res.json(p)
          )
        )
    )
  } catch (err) {
    next(err)
  }
})

router.post('/:id/delete', async (req: any, res: any, next: any) => {
  try {
    //Thread.findByPk(req.params.id).then((thread:any)=>res.json(thread.delete())
  } catch (err) {
    next(err)
  }
})

module.exports = router

